/*
 * Copyright (c) 2005 Versant Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Versant Corporation - initial API and implementation
 */

/**
 * <copyright>
 * </copyright>
 *
 * $Id: ReferenceAttributeImpl.java,v 1.14 2005/09/13 14:16:31 dtinker Exp $
 */
package org.eclipse.jsr220orm.metadata.impl;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.jsr220orm.metadata.AttributeMetaData;
import org.eclipse.jsr220orm.metadata.EmbeddedAttribute;
import org.eclipse.jsr220orm.metadata.EntityMetaData;
import org.eclipse.jsr220orm.metadata.Join;
import org.eclipse.jsr220orm.metadata.JoinPair;
import org.eclipse.jsr220orm.metadata.MetadataPackage;
import org.eclipse.jsr220orm.metadata.OrmColumn;
import org.eclipse.jsr220orm.metadata.ReferenceAttribute;
import org.eclipse.jsr220orm.metadata.TypeMetaData;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Reference Attribute</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.jsr220orm.metadata.impl.ReferenceAttributeImpl#getCascadeType <em>Cascade Type</em>}</li>
 *   <li>{@link org.eclipse.jsr220orm.metadata.impl.ReferenceAttributeImpl#getJoin <em>Join</em>}</li>
 *   <li>{@link org.eclipse.jsr220orm.metadata.impl.ReferenceAttributeImpl#isOneToOne <em>One To One</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ReferenceAttributeImpl extends AttributeMetaDataImpl implements ReferenceAttribute {
	/**
	 * The default value of the '{@link #getCascadeType() <em>Cascade Type</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getCascadeType()
	 * @generated
	 * @ordered
	 */
    protected static final int CASCADE_TYPE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getCascadeType() <em>Cascade Type</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getCascadeType()
	 * @generated
	 * @ordered
	 */
    protected int cascadeType = CASCADE_TYPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getJoin() <em>Join</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getJoin()
	 * @generated
	 * @ordered
	 */
	protected Join join = null;

	/**
	 * The default value of the '{@link #isOneToOne() <em>One To One</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isOneToOne()
	 * @generated
	 * @ordered
	 */
	protected static final boolean ONE_TO_ONE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isOneToOne() <em>One To One</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isOneToOne()
	 * @generated
	 * @ordered
	 */
	protected boolean oneToOne = ONE_TO_ONE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected ReferenceAttributeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected EClass eStaticClass() {
		return MetadataPackage.eINSTANCE.getReferenceAttribute();
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public int getCascadeType() {
		return cascadeType;
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setCascadeType(int newCascadeType) {
		int oldCascadeType = cascadeType;
		cascadeType = newCascadeType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MetadataPackage.REFERENCE_ATTRIBUTE__CASCADE_TYPE, oldCascadeType, cascadeType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Join getJoin() {
		if (join != null && join.eIsProxy()) {
			Join oldJoin = join;
			join = (Join)eResolveProxy((InternalEObject)join);
			if (join != oldJoin) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, MetadataPackage.REFERENCE_ATTRIBUTE__JOIN, oldJoin, join));
			}
		}
		return join;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Join basicGetJoin() {
		return join;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setJoin(Join newJoin) {
		Join oldJoin = join;
		join = newJoin;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MetadataPackage.REFERENCE_ATTRIBUTE__JOIN, oldJoin, join));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isOneToOne() {
		return oneToOne;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOneToOne(boolean newOneToOne) {
		boolean oldOneToOne = oneToOne;
		oneToOne = newOneToOne;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MetadataPackage.REFERENCE_ATTRIBUTE__ONE_TO_ONE, oldOneToOne, oneToOne));
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case MetadataPackage.REFERENCE_ATTRIBUTE__ENTITY_META_DATA:
					if (entityMetaData != null)
						msgs = ((InternalEObject)entityMetaData).eInverseRemove(this, MetadataPackage.ENTITY_META_DATA__ATTRIBUTE_LIST, EntityMetaData.class, msgs);
					return basicSetEntityMetaData((EntityMetaData)otherEnd, msgs);
				case MetadataPackage.REFERENCE_ATTRIBUTE__EMBEDDED_IN:
					if (embeddedIn != null)
						msgs = ((InternalEObject)embeddedIn).eInverseRemove(this, MetadataPackage.EMBEDDED_ATTRIBUTE__ATTRIBUTE_LIST, EmbeddedAttribute.class, msgs);
					return basicSetEmbeddedIn((EmbeddedAttribute)otherEnd, msgs);
				case MetadataPackage.REFERENCE_ATTRIBUTE__MAPPED_BY:
					if (mappedBy != null)
						msgs = ((InternalEObject)mappedBy).eInverseRemove(this, MetadataPackage.ATTRIBUTE_META_DATA__INVERSE_LIST, AttributeMetaData.class, msgs);
					return basicSetMappedBy((AttributeMetaData)otherEnd, msgs);
				case MetadataPackage.REFERENCE_ATTRIBUTE__INVERSE_LIST:
					return ((InternalEList)getInverseList()).basicAdd(otherEnd, msgs);
				case MetadataPackage.REFERENCE_ATTRIBUTE__OVERRIDE_OF:
					if (overrideOf != null)
						msgs = ((InternalEObject)overrideOf).eInverseRemove(this, MetadataPackage.ATTRIBUTE_META_DATA__OVERRIDE_LIST, AttributeMetaData.class, msgs);
					return basicSetOverrideOf((AttributeMetaData)otherEnd, msgs);
				case MetadataPackage.REFERENCE_ATTRIBUTE__OVERRIDE_LIST:
					return ((InternalEList)getOverrideList()).basicAdd(otherEnd, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case MetadataPackage.REFERENCE_ATTRIBUTE__ENTITY_META_DATA:
					return basicSetEntityMetaData(null, msgs);
				case MetadataPackage.REFERENCE_ATTRIBUTE__EMBEDDED_IN:
					return basicSetEmbeddedIn(null, msgs);
				case MetadataPackage.REFERENCE_ATTRIBUTE__MAPPED_BY:
					return basicSetMappedBy(null, msgs);
				case MetadataPackage.REFERENCE_ATTRIBUTE__INVERSE_LIST:
					return ((InternalEList)getInverseList()).basicRemove(otherEnd, msgs);
				case MetadataPackage.REFERENCE_ATTRIBUTE__OVERRIDE_OF:
					return basicSetOverrideOf(null, msgs);
				case MetadataPackage.REFERENCE_ATTRIBUTE__OVERRIDE_LIST:
					return ((InternalEList)getOverrideList()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case MetadataPackage.REFERENCE_ATTRIBUTE__ENTITY_META_DATA:
				if (resolve) return getEntityMetaData();
				return basicGetEntityMetaData();
			case MetadataPackage.REFERENCE_ATTRIBUTE__EMBEDDED_IN:
				if (resolve) return getEmbeddedIn();
				return basicGetEmbeddedIn();
			case MetadataPackage.REFERENCE_ATTRIBUTE__NAME:
				return getName();
			case MetadataPackage.REFERENCE_ATTRIBUTE__JAVA_TYPE:
				if (resolve) return getJavaType();
				return basicGetJavaType();
			case MetadataPackage.REFERENCE_ATTRIBUTE__FETCH_TYPE:
				return new Integer(getFetchType());
			case MetadataPackage.REFERENCE_ATTRIBUTE__OPTIONAL:
				return isOptional() ? Boolean.TRUE : Boolean.FALSE;
			case MetadataPackage.REFERENCE_ATTRIBUTE__GETTER_METHOD_NAME:
				return getGetterMethodName();
			case MetadataPackage.REFERENCE_ATTRIBUTE__SETTER_METHOD_NAME:
				return getSetterMethodName();
			case MetadataPackage.REFERENCE_ATTRIBUTE__MAPPED_BY:
				if (resolve) return getMappedBy();
				return basicGetMappedBy();
			case MetadataPackage.REFERENCE_ATTRIBUTE__INVERSE_LIST:
				return getInverseList();
			case MetadataPackage.REFERENCE_ATTRIBUTE__OVERRIDE_OF:
				if (resolve) return getOverrideOf();
				return basicGetOverrideOf();
			case MetadataPackage.REFERENCE_ATTRIBUTE__OVERRIDE_LIST:
				return getOverrideList();
			case MetadataPackage.REFERENCE_ATTRIBUTE__CASCADE_TYPE:
				return new Integer(getCascadeType());
			case MetadataPackage.REFERENCE_ATTRIBUTE__JOIN:
				if (resolve) return getJoin();
				return basicGetJoin();
			case MetadataPackage.REFERENCE_ATTRIBUTE__ONE_TO_ONE:
				return isOneToOne() ? Boolean.TRUE : Boolean.FALSE;
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case MetadataPackage.REFERENCE_ATTRIBUTE__ENTITY_META_DATA:
				setEntityMetaData((EntityMetaData)newValue);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__EMBEDDED_IN:
				setEmbeddedIn((EmbeddedAttribute)newValue);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__NAME:
				setName((String)newValue);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__JAVA_TYPE:
				setJavaType((TypeMetaData)newValue);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__FETCH_TYPE:
				setFetchType(((Integer)newValue).intValue());
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__OPTIONAL:
				setOptional(((Boolean)newValue).booleanValue());
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__GETTER_METHOD_NAME:
				setGetterMethodName((String)newValue);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__SETTER_METHOD_NAME:
				setSetterMethodName((String)newValue);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__MAPPED_BY:
				setMappedBy((AttributeMetaData)newValue);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__INVERSE_LIST:
				getInverseList().clear();
				getInverseList().addAll((Collection)newValue);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__OVERRIDE_OF:
				setOverrideOf((AttributeMetaData)newValue);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__OVERRIDE_LIST:
				getOverrideList().clear();
				getOverrideList().addAll((Collection)newValue);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__CASCADE_TYPE:
				setCascadeType(((Integer)newValue).intValue());
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__JOIN:
				setJoin((Join)newValue);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__ONE_TO_ONE:
				setOneToOne(((Boolean)newValue).booleanValue());
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case MetadataPackage.REFERENCE_ATTRIBUTE__ENTITY_META_DATA:
				setEntityMetaData((EntityMetaData)null);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__EMBEDDED_IN:
				setEmbeddedIn((EmbeddedAttribute)null);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__JAVA_TYPE:
				setJavaType((TypeMetaData)null);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__FETCH_TYPE:
				setFetchType(FETCH_TYPE_EDEFAULT);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__OPTIONAL:
				setOptional(OPTIONAL_EDEFAULT);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__GETTER_METHOD_NAME:
				setGetterMethodName(GETTER_METHOD_NAME_EDEFAULT);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__SETTER_METHOD_NAME:
				setSetterMethodName(SETTER_METHOD_NAME_EDEFAULT);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__MAPPED_BY:
				setMappedBy((AttributeMetaData)null);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__INVERSE_LIST:
				getInverseList().clear();
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__OVERRIDE_OF:
				setOverrideOf((AttributeMetaData)null);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__OVERRIDE_LIST:
				getOverrideList().clear();
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__CASCADE_TYPE:
				setCascadeType(CASCADE_TYPE_EDEFAULT);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__JOIN:
				setJoin((Join)null);
				return;
			case MetadataPackage.REFERENCE_ATTRIBUTE__ONE_TO_ONE:
				setOneToOne(ONE_TO_ONE_EDEFAULT);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case MetadataPackage.REFERENCE_ATTRIBUTE__ENTITY_META_DATA:
				return entityMetaData != null;
			case MetadataPackage.REFERENCE_ATTRIBUTE__EMBEDDED_IN:
				return embeddedIn != null;
			case MetadataPackage.REFERENCE_ATTRIBUTE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case MetadataPackage.REFERENCE_ATTRIBUTE__JAVA_TYPE:
				return javaType != null;
			case MetadataPackage.REFERENCE_ATTRIBUTE__FETCH_TYPE:
				return fetchType != FETCH_TYPE_EDEFAULT;
			case MetadataPackage.REFERENCE_ATTRIBUTE__OPTIONAL:
				return optional != OPTIONAL_EDEFAULT;
			case MetadataPackage.REFERENCE_ATTRIBUTE__GETTER_METHOD_NAME:
				return GETTER_METHOD_NAME_EDEFAULT == null ? getterMethodName != null : !GETTER_METHOD_NAME_EDEFAULT.equals(getterMethodName);
			case MetadataPackage.REFERENCE_ATTRIBUTE__SETTER_METHOD_NAME:
				return SETTER_METHOD_NAME_EDEFAULT == null ? setterMethodName != null : !SETTER_METHOD_NAME_EDEFAULT.equals(setterMethodName);
			case MetadataPackage.REFERENCE_ATTRIBUTE__MAPPED_BY:
				return mappedBy != null;
			case MetadataPackage.REFERENCE_ATTRIBUTE__INVERSE_LIST:
				return inverseList != null && !inverseList.isEmpty();
			case MetadataPackage.REFERENCE_ATTRIBUTE__OVERRIDE_OF:
				return overrideOf != null;
			case MetadataPackage.REFERENCE_ATTRIBUTE__OVERRIDE_LIST:
				return overrideList != null && !overrideList.isEmpty();
			case MetadataPackage.REFERENCE_ATTRIBUTE__CASCADE_TYPE:
				return cascadeType != CASCADE_TYPE_EDEFAULT;
			case MetadataPackage.REFERENCE_ATTRIBUTE__JOIN:
				return join != null;
			case MetadataPackage.REFERENCE_ATTRIBUTE__ONE_TO_ONE:
				return oneToOne != ONE_TO_ONE_EDEFAULT;
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (cascadeType: ");
		result.append(cascadeType);
		result.append(", oneToOne: ");
		result.append(oneToOne);
		result.append(')');
		return result.toString();
	}

    public void getTopLevelSqlObjects(HashSet sqlObjects) {
    }

    public List getColumns() {
    	if (mappedBy != null) {
    		return super.getColumns();
    	}
        ArrayList cols = new ArrayList(4);
        Join join = getJoin();
        if (join != null) {
            EList pairList = join.getPairList();
            // Done in two for loops to get the sequence right
            for(Iterator pairs = pairList.iterator(); pairs.hasNext();){
                JoinPair pair = (JoinPair) pairs.next();
                cols.add(pair.getSrc());
            }
            for(Iterator pairs = pairList.iterator(); pairs.hasNext();){
                JoinPair pair = (JoinPair) pairs.next();
                cols.add(pair.getDest());
            }
        }
        return cols;
    }

	public void makeNonPersistent() {
		if (join != null) {
			List srcCols = join.getSrcColumns();
			join.delete();
			setJoin(null);
			for (int i = srcCols.size() - 1; i >= 0; i--) {
				((OrmColumn)srcCols.get(i)).delete();
			}
		}
		super.makeNonPersistent();
	}

} //ReferenceAttributeImpl
